/* THE FRACTAL FLOWER   Written by Henry Das                  */
/* originariamente scritto x compilatore Turbo C2.0           */
/* Video 640x480 pixel   16 colori  (VGA Standard MS-DOS)     */
/* Versione Ricorsiva Normale    DEPTH - FIRST                */
/* Versione convertita per compilatore LCC-WIN32              */


#include <windows.h>
# include <math.h>
# include <conio.h>
# include <stdio.h>

# define NOT !
# define OR ||
# define AND &&
# define TRUE 1
# define FALSE 0
# define Pi 3.1415926

int xo=320,yo=860;
int r=0,g=0,b=0;
HDC hddc;

float alfa0,beta0,gamma0,Riduzione;
struct elem2 { float x; float y; };
struct elem3 { float x; float y; float z; };

float sen (float r)
{ return sin(r); }

int Round (float nf)
{ int k;
  float t,f;

  k=(int)nf; t=(float)k;
  f=nf-t;
  if (f>0.50) k++;
  if (f<-0.50) k--;
  return k;
}

void putpixel (int x,int y)
{
	SetPixel(hddc,x,y,RGB(r,g,b));
}

void setcolor (int col)
{ if (col==15) {r=0;g=0;b=255;}
  if (col==14) {r=255;g=0;b=0;}
  if (col==13) {r=0;g=255;b=0;}
  if (col==12) {r=255;g=0;b=0;}
  if (col==11) {r=0;g=255;b=255;}
  if (col==10) {r=0;g=255;b=0;}
  if (col==9) {r=0;g=0;b=255;}
  if (col==8) {r=255;g=0;b=0;}
  if (col==7) {r=0;g=100;b=0;}
}

void swap(int *a, int *b)
{ int t;
  t=*b; *b=*a; *a=t;
}

void dasline (int x1,int y1,int x2,int y2)
{ int x,dx,incx;
  int y,dy,incy;
  int s,i,pxy,sw;

  dx=abs(x2-x1);
  dy=abs(y2-y1);

  if (x1>x2) incx=-1; else incx=1;
  if (y1>y2) incy=-1; else incy=1;

  if (dy>dx) { swap(&dx,&dy); swap(&incx,&incy); swap(&x1,&y1); sw=1; }
  else sw=0;

  pxy=dx;
  dx=dx-dy;
  s=dy;
  x=x1; y=y1;
  if (sw) putpixel(y,x); else  putpixel(x,y);
  for (i=0;i<pxy;i++)
  { x+=incx;
    if (s>0) {s-=dx; y+=incy;} else {s+=dy;}
    if (sw) putpixel(y,x); else putpixel(x,y);
  }
}

void RAss (struct elem3 *Vt, float xo,  float yo,  float zo,
			     float alfa,float beta,float gamma)
{ float x2,y2,z2,x1,y1,z1,x,y,z;

  x2=Vt->x ; y2=Vt->y ; z2=Vt->z ;
  x1=x2*cos(gamma)-z2*sen(gamma);
  z1=x2*sen(gamma)+z2*cos(gamma);
  z=z1*cos(beta)-y2*sen(beta)+zo;
  y1=z1*sen(beta)+y2*cos(beta);
  x=x1*cos(alfa)-y1*sen(alfa)+xo;
  y=x1*sen(alfa)+y1*cos(alfa)+yo;
  Vt->x=x; Vt->y=y; Vt->z=z;
}
void Rids (struct elem3 *vt3,struct elem2 *vt2)
{ float fi,yp;

  vt2->x=-vt3->z*sen(Pi/4)+vt3->x*cos(Pi/4);
  fi=0.5;
  yp=-vt3->x*sen(fi)+vt3->y*cos(fi);
  vt2->y=-vt3->z*sen(fi)+yp*cos(fi);
}
void Co(struct elem2 *vp, struct elem2 *vf)
{ int X1,X2,Y1,Y2;
  X1=xo+(int)(vp->x); Y1=yo-(int)(vp->y);
  X2=xo+(int)(vf->x); Y2=yo-(int)(vf->y);
  dasline(X1,Y1,X2,Y2);
}
void Disegna (float R,float Xo,float Yo,float Zo,
	      float alfa,float beta,float gamma)
{ int i;
  struct elem2 V2[3];
  struct elem3 V3[3];

  V3[1].x=0 ; V3[1].y=R ; V3[1].z=0 ;
  V3[2].x=0 ; V3[2].y=0 ; V3[2].z=0;
  for (i=1;i<3;i++) RAss (&V3[i],Xo,Yo,Zo,alfa,beta,gamma);
  for (i=1;i<3;i++) Rids (&V3[i],&V2[i]);
  Co (&V2[1],&V2[2]);
}
void Frattale (int n, float R,float Xrif,float Yrif,float Zrif,
		      float Rifa,float Rifb,float Rifg)
{ int rip;
  float R1,PasAlfa,PasBeta,PasGamma;
  struct elem3 pv,V3[3];

  if (n<9)
  { V3[1].x=0 ; V3[1].y=R ; V3[1].z=0 ;
    V3[2].x=R ; V3[2].y=0 ; V3[2].z=0;
    R1=R/Riduzione;
    for (rip=1;rip<4;rip++)
    { pv.x=V3[1].x; pv.y=V3[1].y; pv.z=V3[1].z;
      switch (rip)
      { case 1 : PasAlfa=Rifa+alfa0; PasBeta=Rifb+beta0;
		 PasGamma=Rifg+gamma0;
		 break;
	case 2 : PasAlfa=Rifa-alfa0; PasBeta=Rifb-beta0;
		 PasGamma=Rifg-gamma0;
		 break;
	case 3 : PasAlfa=Rifa+alfa0; PasBeta=Rifb-beta0;
		 PasGamma=Rifg-gamma0;
      }
      if (n<2) setcolor(10);
      if ((n>1) AND (n<8)) setcolor(15);
      if (n==8) setcolor(12);
      RAss (&pv,Xrif,Yrif,Zrif,Rifa,Rifb,Rifg);
      Disegna(R1,pv.x,pv.y,pv.z,PasAlfa,PasBeta,PasGamma);
      Frattale(n+1,R1,pv.x,pv.y,pv.z,PasAlfa,PasBeta,PasGamma);
    }
  }
}

void fracto(void)
{
  setcolor(10);
  Riduzione=2.0; alfa0=-0.3; beta0=0.2; gamma0=0.1;
  Frattale(0,500,0,0,0,0,0,0);
}


LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
     HDC         hdc ;
     PAINTSTRUCT ps ;
     RECT        rect ;

     switch (message)
     {
     case WM_CREATE:
          return 0 ;

     case WM_PAINT:
          hdc = BeginPaint (hwnd, &ps) ;

          GetClientRect (hwnd, &rect) ;



		   hddc=hdc;

		   /* setcolor(10) linie(1,1,100,100) */

		    fracto();



		  /* DrawText (hdc, TEXT ("Hello Windows!"), -1, &rect,
                    DT_SINGLELINE | DT_CENTER | DT_VCENTER)  */


          EndPaint (hwnd, &ps) ;
          return 0 ;

     case WM_DESTROY:
          PostQuitMessage (0) ;
          return 0 ;
     }
     return DefWindowProc (hwnd, message, wParam, lParam) ;
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static TCHAR szAppName[] = TEXT ("HelloWin") ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;

     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("This program requires Windows NT!"),
                      szAppName, MB_ICONERROR) ;
          return 0 ;
     }

     hwnd = CreateWindow (szAppName,                  // window class name
                          TEXT ("The Hello Program"), // window caption
                          WS_OVERLAPPEDWINDOW,        // window style
                          CW_USEDEFAULT,              // initial x position
                          CW_USEDEFAULT,              // initial y position
                          CW_USEDEFAULT,              // initial x size
                          CW_USEDEFAULT,              // initial y size
                          NULL,                       // parent window handle
                          NULL,                       // window menu handle
                          hInstance,                  // program instance handle
                          NULL) ;                     // creation parameters

     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
     {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
     }
     return msg.wParam ;
}

























